<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <meta http-equiv="content-type"
 content="text/html; charset=ISO-8859-1">
  <title>Esame</title>
</head>
<body>
<span style="font-weight: bold;">Esame di Sistemi Operativi 1 : 12
Febbraio 2004 </span><br>
<span style="font-weight: bold;"><br>
Testo e soluzioni<br>
</span>
<ol>
  <li><a href="#TIPOA"><span style="font-weight: bold;">Tipo A</span></a></li>
  <li><span style="font-weight: bold;"><a href="#TIPOB">Tipo B</a><br>
    </span></li>
</ol>
<span style="font-weight: bold;"></span>
<hr style="width: 100%; height: 2px;"><span style="font-weight: bold;"><br>
<br>
<a name="TIPOA"></a>TIPO A<br>
<br>
Domanda 1</span>
<br>
Descrivere il metodo di gestione della memoria chiamato segmentazione e
l'architettura di base per <br>
la sua gestione.<br>
<span style="font-weight: bold;"><br>
Risposta:<br>
</span>Suddivisione in "segmenti" di dimensione variabile della memoria
principale....<br>
Gestione con tabella dei segmenti (inizio, limite), ....indirizzi con
segmento, offset nel segmento...ecc<span style="font-weight: bold;"><span
 style="font-weight: bold;"><br>
</span><br>
Domanda 2<br>
</span>Si definiscano i seguenti tre termini:&nbsp; Race
condition,&nbsp;
Starvation,&nbsp;&nbsp; e Deadlock.
<ol>
</ol>
<span style="font-weight: bold;">Risposta:<br>
</span>Vedi libro/lucidi<br>
<br>
<span style="font-weight: bold;">Domanda 3</span><br>
Descrivere le differenze tra sistemi operativi
monolitici, a strati (layered),&nbsp; e a microkernel.<span style="">&nbsp;
</span><span style="font-weight: bold;"><br>
Risposta:<br>
</span>Vedi lucidi<br>
<br>
<span style="font-weight: bold;"><span style="font-weight: bold;">Domanda
4<br>
</span></span>Descrivere e spiegare il significato degli attributi del
file "pluto" risultato del comando "ls" -al:<br>
<br>
&nbsp;-rw-r--r-x&nbsp;&nbsp;&nbsp; giorgio&nbsp;
collab&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 41139 Feb
11 11:20 pluto<br>
<br>
Qual e' l'effetto del comando "chmod 624 pluto"?<br>
<span style="font-weight: bold;"><br>
Risposta:<br>
</span>&nbsp;
-rw-r--r-x: permessi del file: rw- (lettura/scrittura) per owner
(giorgio), r-- (lettura) per gruppo, r-x (lettura esecuzione) per altri
utenti<br>
&nbsp; giorgio: owner<br>
&nbsp; collab: gruppo<br>
&nbsp; 41139: dimensione<br>
&nbsp; Feb 11 11:20 data ora di ult, modifica<br>
&nbsp; pluto: nome <br>
<br>
chmod 624 pluto:<br>
<br>
&nbsp;
-rw--w-r-- &nbsp;&nbsp; giorgio&nbsp;
collab&nbsp;&nbsp; 41139&nbsp; ....&nbsp; pluto<br>
<br>
<span style="font-weight: bold;"><br>
</span><span style="font-weight: bold;"><span style="font-weight: bold;">Domanda
5</span></span><br>
Descrivere la tecnica di allocazione indicizzata dei file,
illustrandone vantaggi e svantaggi in termini di <br>
efficienza
nell'accesso al file e&nbsp; di riduzione della frammentazione.<br>
<br>
<span style="font-weight: bold;">Risposta:<br>
</span>Vedi lucidi<span style="font-weight: bold;"><span
 style="font-weight: bold;"><br>
<br>
</span></span><span style="font-weight: bold;">Esercizio 1<br>
</span>Considerate i seguenti&nbsp; processi <br>
<p class="MsoNormal"><!--[endif]--></p>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 700px;">
  <tbody>
    <tr>
      <td style="vertical-align: top; text-align: left;" rowspan="1"
 colspan="2"><span style="font-weight: bold;">Risorse condivise</span><br>
&nbsp; <span style="font-weight: bold;">semaphore</span>&nbsp; S=<span
 style="font-weight: bold;">1</span>, M=<span style="font-weight: bold;">1</span>;<br>
&nbsp; <span style="font-weight: bold;">int</span> x=10;<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Processo</span>
P1<br>
{<span style="font-weight: bold;"><br>
      </span>&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">down</span>(&amp;M);<br>
&nbsp;&nbsp;&nbsp; x:=x+1;<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">up</span>(&amp;M);<span
 style="font-weight: bold;">&nbsp;&nbsp; <br>
      <br>
      </span><span style="font-weight: bold;">&nbsp;&nbsp; down</span>(&amp;M);<span
 style="font-weight: bold;"><br>
&nbsp;&nbsp; write</span>(x);<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">up</span>(&amp;M);<span
 style="font-weight: bold;"><br>
      <br>
&nbsp;&nbsp; up</span>(&amp;S)<span style="font-weight: bold;">; </span><br>
      <span style="font-weight: bold;"><br>
      </span>}<br>
      </td>
      <td style="vertical-align: top; width: 50%;"><span
 style="font-weight: bold;">Processo</span> P2<br>
{<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">down</span>(&amp;S);<br>
&nbsp; <br>
&nbsp; &nbsp; <span style="font-weight: bold;">down</span>(&amp;M);<br>
&nbsp;&nbsp;&nbsp; x:=x-1;<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">up</span>(&amp;M);<br>
&nbsp; <br>
&nbsp; &nbsp; <span style="font-weight: bold;">down</span>(&amp;M);<span
 style="font-weight: bold;"><br>
&nbsp;&nbsp; write</span>(x);<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">up</span>(&amp;M);<br>
}<br>
      </td>
    </tr>
  </tbody>
</table>
<br>
supponete che i processi vengano eseguiti concorrentemente sulla stessa
CPU.
<p class="MsoHeader" style=""><o:p></o:p></p>
<!--[if !supportEmptyParas]-->
<ol>
  <li>Individuate le regioni critiche nel codice di P1 e P2. <br>
Si possono verificare race conditions per la variabile condivisa x?<br>
    <br>
  </li>
  <li>Determinare tutti i possibili output di tale programma
concorrente (P1 in parallelo con P2).<br>
    <br>
  </li>
  <li>Supponiamo di inizializzare il semaforo&nbsp; <span
 style="font-weight: bold;">S a 0 invece che a 1</span>. <br>
Determinare tutti i possibili output del programma (P1 in parallelo con
P2) modificato. </li>
</ol>
<br>
<span style="font-weight: bold;">
Soluzione<br>
</span>
<ol>
  <li>Regioni critiche: <br>
  </li>
  <ol>
    <li>R1: x:=x+1;</li>
    <li>R2: write(x); <br>
    </li>
    <li>R3: x:=x-1, <br>
    </li>
    <li>R4: write(x)&nbsp; <br>
      <br>
    </li>
  </ol>
  <li>Le regioni critiche sono protette da semafori per cui non vi sono
race conditions su x.<br>
    <br>
  </li>
  <li>Il semaforo S non influisce sul flusso di esecuzione e quindi
l'output dipende dall'ordine di esecuzione<br>
di R1-R2 e R3-R4:</li>
  <ol>
    <li>Prima R1,R3 (in qualsiasi ordine) e poi R2,R4 (in qualsiasi
ordine)--&gt; stampa: 10 10<br>
    </li>
    <li>R1 R2 R3 R4 --&gt; stampa: 11 10</li>
    <li>R3 R4 R1 R2 --&gt; stampa:&nbsp; 9&nbsp; 10<br>
      <br>
    </li>
  </ol>
  <li>Il semaforo forza l'ordine di esecuzione P1 -&gt; P2 e quindi ci
sara' un solo output: 11 10<br>
  </li>
</ol>
<br>
<br clear="all">
<span style="font-weight: bold;">Esercizio 2</span>
<br>
Considerare
un insieme di cinque processi P<sub>1</sub><span
 style="font-family: Arial;">, </span>P<sub>2</sub>, P<sub>3 </sub><span
 style="font-family: Arial;">, </span>P<sub>4</sub>, P<sub>5</sub> con
i seguenti
tempi di arrivo e tempi <br>
di esecuzione in millisecondi:
<div class="Section1">
<p class="MsoNormal"
 style="margin-left: 15.3pt; text-align: justify; line-height: 13.6pt;"><!--[if !supportEmptyParas]--><!--[endif]--><o:p></o:p></p>
<table border="1" cellpadding="3">
  <tbody>
    <tr>
      <td width="72" valign="top"
 style="border: 0.75pt solid windowtext; padding: 0cm 4.25pt; width: 53.85pt;">
      <p class="MsoNormal" style="text-align: justify;">Processo</p>
      </td>
      <td
 style="border-style: solid solid solid none; border-width: 0.75pt 0.75pt 0.75pt medium; border-top: 0.75pt solid windowtext; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; vertical-align: top; width: 89.55pt;">
      <p class="MsoNormal" style="text-align: justify;">Tempo di arrivo</p>
      </td>
      <td
 style="border-style: solid solid solid none; border-width: 0.75pt 0.75pt 0.75pt medium; border-top: 0.75pt solid windowtext; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; vertical-align: top; width: 111.7pt;">
      <p class="MsoNormal" style="text-align: justify;">Tempo di
esecuzione</p>
      </td>
    </tr>
    <tr>
      <td width="72" valign="top"
 style="border-style: none solid solid; border-width: medium 0.75pt 0.75pt; border-left: 0.75pt solid windowtext; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; width: 53.85pt;">
      <p class="MsoNormal" style="text-align: justify;">P<sub>1</sub></p>
      </td>
      <td width="119" valign="top"
 style="border-style: none solid solid none; border-width: medium 0.75pt 0.75pt medium; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; width: 89.55pt;">
      <p>0</p>
      </td>
      <td
 style="border-style: none solid solid none; border-width: medium 0.75pt 0.75pt medium; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; vertical-align: top; width: 111.7pt;">
      <p class="MsoNormal">9</p>
      </td>
    </tr>
    <tr>
      <td width="72" valign="top"
 style="border-style: none solid solid; border-width: medium 0.75pt 0.75pt; border-left: 0.75pt solid windowtext; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; width: 53.85pt;">
      <p class="MsoNormal" style="text-align: justify;">P<sub>2</sub></p>
      </td>
      <td
 style="border-style: none solid solid none; border-width: medium 0.75pt 0.75pt medium; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; vertical-align: top; width: 89.55pt;">
      <p class="MsoNormal" style="text-align: justify;">3</p>
      </td>
      <td width="149" valign="top"
 style="border-style: none solid solid none; border-width: medium 0.75pt 0.75pt medium; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; width: 111.7pt;">
      <p class="MsoNormal" style="text-align: justify;">17</p>
      </td>
    </tr>
    <tr>
      <td width="72" valign="top"
 style="border-style: none solid solid; border-width: medium 0.75pt 0.75pt; border-left: 0.75pt solid windowtext; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; width: 53.85pt;">
      <p class="MsoNormal" style="text-align: justify;">P<sub>3</sub></p>
      </td>
      <td width="119" valign="top"
 style="border-style: none solid solid none; border-width: medium 0.75pt 0.75pt medium; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; width: 89.55pt;">
      <p class="MsoNormal" style="text-align: justify;">7</p>
      </td>
      <td width="149" valign="top"
 style="border-style: none solid solid none; border-width: medium 0.75pt 0.75pt medium; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; width: 111.7pt;">
      <p class="MsoNormal" style="text-align: justify;">10</p>
      </td>
    </tr>
    <tr style="height: 13.1pt;">
      <td width="72" valign="top"
 style="border-style: none solid solid; border-width: medium 0.75pt 0.75pt; border-left: 0.75pt solid windowtext; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; width: 53.85pt; height: 13.1pt;">
      <p class="MsoNormal" style="text-align: justify;">P<sub>4</sub></p>
      </td>
      <td width="119" valign="top"
 style="border-style: none solid solid none; border-width: medium 0.75pt 0.75pt medium; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; width: 89.55pt; height: 13.1pt;">
      <p class="MsoNormal" style="text-align: justify;">11</p>
      </td>
      <td width="149" valign="top"
 style="border-style: none solid solid none; border-width: medium 0.75pt 0.75pt medium; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; width: 111.7pt; height: 13.1pt;">
      <p class="MsoNormal" style="text-align: justify;">9</p>
      </td>
    </tr>
    <tr style="height: 4.2pt;">
      <td width="72" valign="top"
 style="border-style: none solid solid; border-width: medium 0.75pt 0.75pt; border-left: 0.75pt solid windowtext; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; width: 53.85pt; height: 4.2pt;">
      <p class="MsoNormal" style="text-align: justify;">P<sub>5</sub></p>
      </td>
      <td width="119" valign="top"
 style="border-style: none solid solid none; border-width: medium 0.75pt 0.75pt medium; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; width: 89.55pt; height: 4.2pt;">
      <p class="MsoNormal"
 style="margin-left: 14.7pt; text-align: justify; text-indent: -14.7pt;">15</p>
      </td>
      <td width="149" valign="top"
 style="border-style: none solid solid none; border-width: medium 0.75pt 0.75pt medium; border-right: 0.75pt solid windowtext; border-bottom: 0.75pt solid windowtext; padding: 0cm 4.25pt; width: 111.7pt; height: 4.2pt;">
      <p class="MsoNormal"
 style="margin-left: 14.7pt; text-align: justify; text-indent: -14.7pt;">6<br>
      </p>
      <br>
      </td>
    </tr>
  </tbody>
</table>
</div>
<span style="font-size: 12pt; font-family: &quot;Times New Roman&quot;;"></span><br>
Assegnare
questo insieme di
processi ad un processore in base alla politica Round Robin
considerando <br>
un
quanto di&nbsp; tempo di 4 millisecondi.
Calcolare il valor medio del tempo
di attesa ed il valor medio del <br>
tempo di turnaround(completamento) dei
processi.
<br>
<div class="Section2"><br>
<br>
<div class="Section2"><span style="font-weight: bold;">Soluzione</span>&nbsp;
<p style=""><span lang="EN-GB" style=""> <o:p></o:p></span></p>
<table border="1" cellpadding="0" width="765" style="width: 573.65pt;">
  <tbody>
    <tr>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>1</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>2</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>1</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>3</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>2</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>4</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>1</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>5</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>3</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>2</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>4</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>5</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>3</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>2</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.38%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 lang="EN-GB" style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>4</sub></span></b><span
 lang="EN-GB" style=""><o:p></o:p></span></p>
      </td>
      <td width="6%"
 style="padding: 0.75pt; background: silver none repeat scroll 0% 50%; -moz-background-clip: initial; -moz-background-inline-policy: initial; -moz-background-origin: initial; width: 6.26%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><b><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">P<sub>2</sub></span></b></p>
      </td>
    </tr>
    <tr>
      <td width="6%" style="padding: 0.75pt; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">0-4</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">4-8</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">8-12</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">12-16</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">16-20</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">20-24</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">24-25</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">25-29</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">29-33</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">33-37</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">37-41</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">41-43</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.4%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">43-45</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.38%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">45-49</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.26%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">49-50</span></p>
      </td>
      <td width="6%" style="padding: 0.75pt; width: 6.26%;">
      <p class="MsoNormal" align="center" style="text-align: center;"><span
 style="font-size: 10pt; font-family: &quot;Courier New&quot;;">50-51</span></p>
      </td>
    </tr>
  </tbody>
</table>
<br>
Nota: Quando arriva P3 P1 e' gia in coda! Quindi allo scadere del II
quanto viene schedulato di nuovo <br>
P1 (la strategia di base&nbsp; e' sempre FIFO) e cosi via....<br>
<ol>
  <li>Tempo di attesa=Tempo di completamento-Tempo di esecuzione<br>
Media tempo di attesa dei
processi: ((25-0-9)+(51-3-17)+(45-7-10)+(50-11-9)+(43-15-6) = 127/5 <br>
    <br>
  </li>
  <li>Tempo di completamento= Istante di completamento - Tempo di arrivo<br>
Valore
medio del
tempo di turnaround dei processi: (25+(51-3)+(45-7)+(50-11)+(43-15))/5
=
178/5</li>
</ol>
<div class="MsoNormal" align="center" style="text-align: center;">
</div>
</div>
<br>
<div class="MsoNormal" align="center" style="text-align: center;"></div>
</div>
<span style="font-weight: bold;">Esercizio 3</span><br>
Considerare la seguente stringa di riferimenti alla memoria di un
processo
in un sistema con memoria virtuale<br>
<p>S = 10 6 2 4 6 8 3 1 4 5 11 8 7 6 10 9 7 8 11 2<br>
</p>
<p>Illustrare il comportamento dell'algoritmo LRU di sostituzione delle
pagine per una memoria fisica <br>
di 5 blocchi.&nbsp; Calcolare il numero di page
fault che si verificano.<br>
</p>
<span style=""><o:p></o:p></span>
<ol>
</ol>
<!--[if !supportEmptyParas]-->
<span style="font-weight: bold;"><br>
Soluzione<br>
<br>
</span>
<table cellpadding="2" cellspacing="2" border="1"
 style="text-align: left; width: 100%;">
  <tbody>
    <tr>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">Rif.<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">10<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">6<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">2<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">4<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">6<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">8<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">3<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">1<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">4<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">5<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">11<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">8<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">7<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">6<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">10<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">9<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">7<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">8<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">11<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">2<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">10</span><br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">3</span><br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">6</span><br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">5</span><br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top; font-weight: bold;">10<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">2</span><br>
      </td>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">1</span><br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">4</span><br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">6</span><br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">8</span><br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">11</span><br>
      </td>
      <td style="vertical-align: top;">9<br>
      </td>
      <td style="vertical-align: top;">9<br>
      </td>
      <td style="vertical-align: top;">9<br>
      </td>
      <td style="vertical-align: top;">9<br>
      </td>
      <td style="vertical-align: top;">9<br>
      </td>
    </tr>
    <tr>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">Page
Fault<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);"><br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);"><br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);"><br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);"><br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
    </tr>
  </tbody>
</table>
<span style="font-weight: bold;"><br>
In neretto: </span>pagina selezionata<span style="font-weight: bold;"><br>
Numero di page fault: </span>16<br>
<span style="font-weight: bold;"><br>
Esercizio 4<br>
</span>Data una memoria <span style="font-weight: bold;">partizionata
in maniera fissa</span> come segue:<span style="font-weight: bold;"><br>
<br>
</span>
<table cellpadding="2" cellspacing="2" border="1"
 style="text-align: left; width: 200px;">
  <tbody>
    <tr>
      <td style="vertical-align: top;">Partizione<br>
      </td>
      <td style="vertical-align: top;">Dimensione<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">0</td>
      <td style="vertical-align: top;">200K</td>
    </tr>
    <tr>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">500K</td>
    </tr>
    <tr>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">300K</td>
    </tr>
    <tr>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">600K</td>
    </tr>
  </tbody>
</table>
<span style="font-weight: bold;">
<br>
</span>e dato che il sistema operativo deve allocare
quattro processi P1 di 212K, P2 di 417K, P3 di 112K e P4 di 427K <br>
(in quest'ordine),&nbsp; scrivere
in quale partizione&nbsp; il sistema alloca ciascun processo se viene
usato
l'algoritmo:<span style="font-weight: bold;"><br>
</span>
<ol>
  <li>First Fit</li>
  <li>Best Fit</li>
  <li>Worst Fit<br>
  </li>
</ol>
(se il processo non puo' essere
allocato, segnare "X" come partizione).<br>
<br>
<span style="font-weight: bold;">Soluzione</span><br>
Nota: le partizioni sono <span style="font-weight: bold;">fisse</span>:
non si possono mettere due processi nella stessa partizione!<br>
<ol>
  <li>First fit: P1:1, P2: 3, P3:0, P4:X<br>
  </li>
  <li>Best fit:&nbsp; P1:2, P2: 1, P3:0, P4:3</li>
  <li>Worst fit: P1:3, P2:1, P3:2, P4:X</li>
</ol>
<br>
<span style="font-weight: bold;">Esercizio 5</span><br>
Considerare un file system dove la dimensione di un
blocco logico e' 2KB e con indirizzi di blocchi a 16 bit.<br>
<ol>
  <li>Determinare la dimensione massima di un file in caso
di</li>
  <ol>
    <li>allocazione concatenata</li>
    <li>allocazione indicizzata con due livelli di blocco indice<br>
      <br>
    </li>
  </ol>
  <li>Determinare il numero di blocchi effettivamente assegnati ad un
file di
200KB per i due tipi di allocazione.<br>
  </li>
</ol>
<span style="font-weight: bold;">Soluzione<br>
</span>Indirizzi a 16 bit --&gt; 2<sup>16</sup> blocchi fisici<sup><br>
</sup>
<ol>
  <li>Dim. massima</li>
  <ol>
    <li>Allocazione concatenata: ogni blocco ha 2KB-2B=2046 Byte di
spazio dati quindi il file piu grande ha dimensione 2<sup>16</sup> *
2046 Byte</li>
    <li>Allocazione indicizzata: ogni blocco puo contenere 2048/2=1024
puntatori, quindi con due livelli: (1024)<sup>2</sup>*2 K (senza
considerare spazio per la tabella)<br>
      <br>
    </li>
  </ol>
  <li>Numero blocchi</li>
  <ol>
    <li>&nbsp;Dim file/Spazio in un blocco = 200 KB/2046 = 101 blocchi<br>
    </li>
    <li>&nbsp;100 blocchi</li>
  </ol>
</ol>
<br>
<hr style="width: 100%; height: 2px;"><br>
<a name="TIPOB"></a>&nbsp; <span style="font-weight: bold;">TIPO B</span><br>
<br>
<span style="font-weight: bold;"><br>
Domanda 1</span>
<br>
Cos'e', come viene
usata e come puo' essere&nbsp; implementata l'istruzione Test &amp; Set?<br>
<span style="font-weight: bold;">Risposta:<br>
</span>Istruzione che testa e imposta il valore di una
variabile/registro in modo atomico...<br>
Utilizzata per implementare ad es. spinlock....(esempio)<br>
Implementata o a livello hardware o software se si hannp costrutti
"atomici"...<br>
<span style="font-weight: bold;"><span style="font-weight: bold;">
</span></span><br>
<span style="font-weight: bold;">
Domanda 2</span><br>
Si descrivano brevemente caratteristiche e differenze di job, processi,
thread e fibre in Windows 2000.
<br>
<span style="font-weight: bold;"><br>
</span><span style="font-weight: bold;">Risposta: <br>
</span>In Windows 2000: job = collezione di processi, ....<span
 style="font-weight: bold;"><br>
</span><span style="font-weight: bold;"><br>
Domanda 3</span><br>
Descrivere due diverse strategie per la gestione dei "nomi" dei file in
una directory.<br>
<span style="font-weight: bold;"><br>
Risposta: <br>
</span>I record di una directory possono avere dimensione fissa o
variabile.<br>
Nel primo caso se i nomi hanno lunghezza variabile si puo fissare la
dim. max utlizzare<br>
un puntatore ad uno heap che mantiene l'insieme dei nomi separati da un
carattere speciale....<br>
<span style="font-weight: bold;"><br>
</span>
<span style="font-weight: bold;"><span style="font-weight: bold;">Domanda
4<br>
</span></span>Descrivere e spiegare il significato degli attributi del
file "esempio" risultato del comando "ls" -al:<br>
<br>
drwxr-x--x&nbsp;&nbsp;&nbsp;&nbsp; giorgio&nbsp;
collab&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 4096 Feb 11 11:20 esempio<br>
<br>
Qual e' l'effetto del comando "chmod 523 esempio"?<br>
<span style="font-weight: bold;">Risposta:<br>
</span>&nbsp; d: il file e' una directory (x= permesso di entrare nella
dir.)<br>
&nbsp; rwxr-x--x : permessi del file: rwx (lettura/scrittura/entrare)
per owner
(giorgio), r-x (lettura/entrare) per gruppo, --x (entrare) per altri
utenti<br>
&nbsp; giorgio: owner<br>
&nbsp; collab: gruppo<br>
&nbsp; 4096: dimensione directory<br>
&nbsp; Feb 11 11:20 data ora di ult, modifica<br>
&nbsp; esempio: nome <br>
<br>
chmod 523 pluto:<br>
<br>
&nbsp;
-r-x-w--wx &nbsp;&nbsp; giorgio&nbsp;
collab&nbsp;&nbsp; 4096&nbsp; ....&nbsp; esempio<br>
<span style="font-weight: bold;"><span style="font-weight: bold;"><br>
Domanda 5</span></span><br>
Descrivere la struttura della MFT e il contenuto di un suo record.<br>
In quel formato vengono memorizzate le informazioni sui blocchi di dati
per un file con le seguenti<br>
caratteristiche:&nbsp; 7 blocchi con indirizzi fisici&nbsp;
10,11,21,22,23,45,46.<br>
<span style="font-weight: bold;"><br>
</span><span style="font-weight: bold;">Risposta:<br>
</span>MFT/MFT record&nbsp;<span style="font-weight: bold;"> ... </span>vedi
lucidi<span style="font-weight: bold;"><br>
</span>Blocchi:&nbsp;&nbsp; 0:7 - 10:2 - 21:3 - 45:2<br>
<br>
<span style="font-weight: bold;">Esercizio 1<br>
</span>Considerate i seguenti&nbsp; processi <br>
<p class="MsoNormal"><!--[endif]--></p>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 700px;">
  <tbody>
    <tr>
      <td style="vertical-align: top; text-align: left;" rowspan="1"
 colspan="2"><span style="font-weight: bold;">Risorse condivise</span><br>
&nbsp; <span style="font-weight: bold;">semaphore</span>&nbsp; S=0,
M=1;<br>
&nbsp; <span style="font-weight: bold;">int</span> x=10;<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Processo</span>
P1<br>
{<span style="font-weight: bold;"><br>
      </span>&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">down</span>(&amp;M);<br>
&nbsp;&nbsp;&nbsp; x:=x+1;<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">up</span>(&amp;M);<span
 style="font-weight: bold;">&nbsp;&nbsp; <br>
      <br>
      </span><span style="font-weight: bold;">&nbsp;&nbsp; down</span>(&amp;M);<span
 style="font-weight: bold;"><br>
&nbsp;&nbsp; write</span>(x);<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">up</span>(&amp;M);<span
 style="font-weight: bold;"><br>
      <br>
&nbsp;&nbsp; up</span>(&amp;S)<span style="font-weight: bold;">; </span><br>
      <span style="font-weight: bold;"><br>
      </span>}<br>
      </td>
      <td style="vertical-align: top; width: 50%;"><span
 style="font-weight: bold;">Processo</span> P2<br>
{<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">down</span>(&amp;S);<br>
&nbsp; <br>
&nbsp; &nbsp; <span style="font-weight: bold;">down</span>(&amp;M);<br>
&nbsp;&nbsp;&nbsp; x:=x-1;<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">up</span>(&amp;M);<br>
&nbsp; <br>
&nbsp; &nbsp; <span style="font-weight: bold;">down</span>(&amp;M);<span
 style="font-weight: bold;"><br>
&nbsp;&nbsp; write</span>(x);<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">up</span>(&amp;M);<br>
}<br>
      </td>
    </tr>
  </tbody>
</table>
<br>
supponete che i processi vengano eseguiti concorrentemente sulla stessa
CPU.
<p class="MsoHeader" style=""><o:p></o:p></p>
<!--[if !supportEmptyParas]-->
<ol>
  <li>Individuate le regioni critiche nel codice di P1 e P2. <br>
Si possono verificare race conditions per la variabile condivisa x?<br>
    <br>
  </li>
  <li>Determinare tutti i possibili output di tale programma
concorrente (P1 in parallelo con P2).<br>
    <br>
  </li>
  <li>Supponiamo di inizializzare il semaforo <span
 style="font-weight: bold;">S a 1 invece che a 0</span>. <br>
Determinare tutti i possibili output del programma (P1 in parallelo con
P2) modificato. </li>
</ol>
<span style="font-weight: bold;">
<br>
</span><span style="font-weight: bold;">
Soluzione<br>
</span>
<ol>
  <li>Regioni critiche: <br>
  </li>
  <ol>
    <li>R1: x:=x+1;</li>
    <li>R2: write(x); <br>
    </li>
    <li>R3: x:=x-1, <br>
    </li>
    <li>R4: write(x)<br>
    </li>
  </ol>
</ol>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; Le regioni critiche sono
protette da semafori per cui non vi sono race conditions su x<br>
<ol>
  <li>Il semaforo forza l'ordine di esecuzione P1 -&gt; P2 e quindi ci
sara' un solo output: 11 10<br>
    <br>
  </li>
  <li>Il semaforo S non influisce sul flusso di esecuzione e quindi
l'output dipende dall'ordine di esecuzione<br>
di R1-R2 e R3-R4:</li>
  <ol>
    <li>Prima R1,R3 (in qualsiasi ordine) e poi R2,R4 (in qualsiasi
ordine)--&gt; stampa: 10 10<br>
    </li>
  </ol>
  <ol>
    <li>R1 R2 R3 R4 --&gt; stampa: 11 10</li>
  </ol>
  <ol>
    <li>R3 R4 R1 R2 --&gt; stampa:&nbsp; 9&nbsp; 10</li>
  </ol>
</ol>
<span style="font-weight: bold;">
<br>
<br>
Esercizio 2</span><br>
Considerare un insieme di cinque processi <b><i>P<sub>1</sub></i></b>,
<b><i>P<sub>2</sub></i></b>, <b><i>P<sub>3</sub></i></b>, <b><i>P<sub>4</sub></i></b>,
<b><i>P<sub>5</sub></i></b>&nbsp;<b><i><sub> </sub></i></b>con i
seguenti
tempi di arrivo e tempi di <br>
esecuzione in millisecondi:
<p></p>
<p>
</p>
<p>
</p>
<p>
</p>
<p>
</p>
<p>
</p>
<p>
</p>
<p>
</p>
<p>
</p>
<p>
</p>
<p>
</p>
<p>
</p>
<p>
</p>
<p>
</p>
<p>
</p>
<p>
</p>
<table border="1" cellpadding="3">
  <tbody>
    <tr>
      <td align="left">Processo</td>
      <td align="left">Tempo di arrivo</td>
      <td align="left">Tempo di esecuzione</td>
    </tr>
    <tr>
      <td align="left"><b><i>P<sub>1</sub></i></b></td>
      <td align="left">11</td>
      <td align="left">7</td>
    </tr>
    <tr>
      <td align="left"><b><i>P<sub>2</sub></i></b></td>
      <td align="left">5</td>
      <td align="left">5</td>
    </tr>
    <tr>
      <td align="left"><b><i>P<sub>3</sub></i></b></td>
      <td align="left">10</td>
      <td align="left">10</td>
    </tr>
    <tr>
      <td align="left"><b><i>P<sub>4</sub></i></b></td>
      <td align="left">6</td>
      <td align="left">9</td>
    </tr>
    <tr>
      <td align="left"><b><i>P<sub>5</sub></i></b></td>
      <td align="left">0</td>
      <td align="left">17</td>
    </tr>
  </tbody>
</table>
<br>
Assegnare questo insieme di processi ad un processore in base alla
politica
Round Robin considerando <br>
un quanto di tempo di 4 millisecondi. Calcolare
il valor medio del tempo di attesa ed il valor medio del tempo <br>
di
turnaround
(completamento) dei processi.<br>
<br>
<span style="font-weight: bold;">Soluzione</span><br
 style="font-weight: bold;">
<br>
<center>
<table border="1" width="963" height="19">
  <tbody>
    <tr>
      <td align="center" width="57" height="19" bgcolor="#c0c0c0">
      <center>P5</center>
      </td>
      <td align="center" width="57" height="19" bgcolor="#c0c0c0">
      <center>P5</center>
      </td>
      <td align="center" width="58" height="19" bgcolor="#c0c0c0">P2</td>
      <td align="center" width="58" height="19" bgcolor="#c0c0c0">P4</td>
      <td align="center" width="58" height="19" bgcolor="#c0c0c0">P5</td>
      <td align="center" width="58" height="19" bgcolor="#c0c0c0">P3</td>
      <td align="center" width="58" height="19" bgcolor="#c0c0c0">P1</td>
      <td align="center" width="58" height="19" bgcolor="#c0c0c0">P2</td>
      <td align="center" width="58" height="19" bgcolor="#c0c0c0">P4</td>
      <td align="center" width="58" height="19" bgcolor="#c0c0c0">P5</td>
      <td align="center" width="58" height="19" bgcolor="#c0c0c0">P3</td>
      <td align="center" width="58" height="19" bgcolor="#c0c0c0">P1</td>
      <td align="center" width="58" height="19" bgcolor="#c0c0c0">P4</td>
      <td align="center" width="58" height="19" bgcolor="#c0c0c0">P5</td>
      <td align="center" width="79" height="19" bgcolor="#c0c0c0">P3</td>
    </tr>
    <tr>
      <td align="center" width="57" height="19"><br>
      </td>
      <td align="center" width="57" height="19"><br>
      </td>
      <td align="center" width="58" height="19"><br>
      </td>
      <td align="center" width="58" height="19"><br>
      </td>
      <td align="center" width="58" height="19"><br>
      </td>
      <td align="center" width="58" height="19"><br>
      </td>
      <td align="center" width="58" height="19"><br>
      </td>
      <td align="center" width="58" height="19"><br>
      </td>
      <td align="center" width="58" height="19"><br>
      </td>
      <td align="center" width="58" height="19"><br>
      </td>
      <td align="center" width="58" height="19"><br>
      </td>
      <td align="center" width="58" height="19"><br>
      </td>
      <td align="center" width="58" height="19"><br>
      </td>
      <td align="center" width="58" height="19"><br>
      </td>
      <td align="center" width="79" height="19"><br>
      </td>
    </tr>
    <tr>
      <td align="center" width="57" height="33"><font size="+0">0-4ms</font></td>
      <td align="center" width="57" height="33"><font size="+0">4-8</font></td>
      <td align="center" width="58" height="33"><font size="+0">8-12</font></td>
      <td align="center" width="58" height="33"><font size="+0">12-16</font></td>
      <td align="center" width="58" height="33"><font size="+0">16-20</font></td>
      <td align="center" width="58" height="33"><font size="+0">20-24</font></td>
      <td align="center" width="58" height="33"><font size="+0">24-28</font></td>
      <td align="center" width="58" height="33"><font size="+0">28-29</font></td>
      <td align="center" width="58" height="33"><font size="+0">29-33</font></td>
      <td align="center" width="58" height="33"><font size="+0">33-37</font></td>
      <td align="center" width="58" height="33"><font size="+0">37-41</font></td>
      <td align="center" width="58" height="33"><font size="+0">41-44</font></td>
      <td align="center" width="58" height="33"><font size="+0">44-45</font></td>
      <td align="center" width="58" height="33"><font size="+0">45-46</font></td>
      <td align="center" width="79" height="33">46 - 48</td>
      <td align="center" width="70" height="33">48ms<br>
      </td>
    </tr>
  </tbody>
</table>
</center>
<br>
<ol>
  <li>Tempo di attesa=Tempo di completamento-Tempo di esecuzione<br>
Media tempo di attesa dei
processi: ((44-11-7)+(29-5-5)+(48-10-10)+(45-6-9)+(46-0-17)/5 <br>
    <br>
  </li>
  <li>Tempo di completamento= Istante di completamento - Tempo di arrivo<br>
Valore
medio del
tempo di turnaround dei processi:
(44-11)+(29-5)+(48-10)+(45-6)+(46-0)/5 = 180/5<br>
  </li>
</ol>
<br>
<span style="font-weight: bold;">Esercizio 3</span><br>
Considerare la seguente stringa di riferimenti alla memoria
di un processo in un sistema con memoria virtuale
<br>
<br>
S = 20 18 15 10 6 2 15 18 20 6 10 11 8 6 10 9 7 8 11 2
Illustrare il comportamento dell'algoritmo LRU di sostituzione delle
<br>
pagine per una memoria fisica di 5 blocchi.
<br>
Calcolare il numero di page fault che si verificano.<br>
<span style="font-weight: bold;"><br>
</span><span style="text-decoration: underline;"><br>
<span style="font-weight: bold;">Soluzione</span></span><span
 style="font-weight: bold;">&nbsp; </span><br>
&nbsp;<span style="background-color: rgb(255, 0, 0);">Pagina Riferita</span>
<div align="center">
<center>
<table border="1" width="728" height="39">
  <tbody>
    <tr>
      <td width="34" height="39" bgcolor="#c0c0c0" align="center">&nbsp;</td>
      <td width="34" height="39" bgcolor="#c0c0c0" align="center">20</td>
      <td width="34" height="39" bgcolor="#c0c0c0" align="center">18</td>
      <td width="34" height="39" bgcolor="#c0c0c0" align="center">15</td>
      <td width="34" height="39" bgcolor="#c0c0c0" align="center">10</td>
      <td width="34" height="39" bgcolor="#c0c0c0" align="center">6</td>
      <td width="34" height="39" bgcolor="#c0c0c0" align="center">2</td>
      <td width="34" height="39" bgcolor="#c0c0c0" align="center">15</td>
      <td width="34" height="39" bgcolor="#c0c0c0" align="center">18</td>
      <td width="34" height="39" bgcolor="#c0c0c0" align="center">20</td>
      <td width="34" height="39" bgcolor="#c0c0c0" align="center">6</td>
      <td width="35" height="39" bgcolor="#c0c0c0" align="center">10</td>
      <td width="35" height="39" bgcolor="#c0c0c0" align="center">11</td>
      <td width="35" height="39" bgcolor="#c0c0c0" align="center">8</td>
      <td width="35" height="39" bgcolor="#c0c0c0" align="center">6</td>
      <td width="35" height="39" bgcolor="#c0c0c0" align="center">10</td>
      <td width="35" height="39" bgcolor="#c0c0c0" align="center">9</td>
      <td width="35" height="39" bgcolor="#c0c0c0" align="center">7</td>
      <td width="35" height="39" bgcolor="#c0c0c0" align="center">8</td>
      <td width="35" height="39" bgcolor="#c0c0c0" align="center">11</td>
      <td width="35" height="39" bgcolor="#c0c0c0" align="center">2</td>
    </tr>
    <tr>
      <td width="34" height="39" bordercolor="#C0C0C0" bgcolor="#c0c0c0"
 align="center">0</td>
      <td width="34" height="39" align="center" bgcolor="#ff0000">20</td>
      <td width="34" height="39" align="center">20</td>
      <td width="34" height="39" align="center">20</td>
      <td width="34" height="39" align="center">20</td>
      <td width="34" height="39" align="center">20</td>
      <td width="34" height="39" align="center" bgcolor="#ff0000"><span
 style="background-color: rgb(255, 0, 0);">2</span></td>
      <td width="34" height="39" align="center">2</td>
      <td width="34" height="39" align="center">2</td>
      <td width="34" height="39" align="center">2</td>
      <td width="34" height="39" align="center">2</td>
      <td width="35" height="39" align="center" bgcolor="#ff0000">10</td>
      <td width="35" height="39" align="center">10</td>
      <td width="35" height="39" align="center">10</td>
      <td width="35" height="39" align="center">10</td>
      <td width="35" height="39" align="center">10</td>
      <td width="35" height="39" align="center">10</td>
      <td width="35" height="39" align="center">10</td>
      <td width="35" height="39" align="center">10</td>
      <td width="35" height="39" align="center">10</td>
      <td width="35" height="39" align="center" bgcolor="#ff0000">2</td>
    </tr>
    <tr>
      <td width="34" height="39" bordercolor="#C0C0C0" bgcolor="#c0c0c0"
 align="center">1</td>
      <td width="34" height="39" align="center"><br>
      </td>
      <td width="34" height="39" align="center" bgcolor="#ff0000">18</td>
      <td width="34" height="39" align="center">18</td>
      <td width="34" height="39" align="center">18</td>
      <td width="34" height="39" align="center">18</td>
      <td width="34" height="39" align="center">18</td>
      <td width="34" height="39" align="center">18</td>
      <td width="34" height="39" align="center">18</td>
      <td width="34" height="39" align="center">18</td>
      <td width="34" height="39" align="center">18</td>
      <td width="35" height="39" align="center">18</td>
      <td width="35" height="39" align="center">18</td>
      <td width="35" height="39" align="center" bgcolor="#ff0000">8</td>
      <td width="35" height="39" align="center">8</td>
      <td width="35" height="39" align="center">8</td>
      <td width="35" height="39" align="center">8</td>
      <td width="35" height="39" align="center">8</td>
      <td width="35" height="39" align="center">8</td>
      <td width="35" height="39" align="center">8</td>
      <td width="35" height="39" align="center">8</td>
    </tr>
    <tr>
      <td width="34" height="39" bordercolor="#C0C0C0" bgcolor="#c0c0c0"
 align="center">2</td>
      <td width="34" height="39" align="center"><br>
      </td>
      <td width="34" height="39" align="center"><br>
      </td>
      <td width="34" height="39" align="center" bgcolor="#ff0000">15</td>
      <td width="34" height="39" align="center">15</td>
      <td width="34" height="39" align="center">15</td>
      <td width="34" height="39" align="center">15</td>
      <td width="34" height="39" align="center">15</td>
      <td width="34" height="39" align="center">15</td>
      <td width="34" height="39" align="center">15</td>
      <td width="34" height="39" align="center">15</td>
      <td width="35" height="39" align="center">15</td>
      <td width="35" height="39" align="center" bgcolor="#ff0000">11</td>
      <td width="35" height="39" align="center">11</td>
      <td width="35" height="39" align="center">11</td>
      <td width="35" height="39" align="center">11</td>
      <td width="35" height="39" align="center">11</td>
      <td width="35" height="39" align="center" bgcolor="#ff0000">7</td>
      <td width="35" height="39" align="center">7</td>
      <td width="35" height="39" align="center">7</td>
      <td width="35" height="39" align="center">7</td>
    </tr>
    <tr>
      <td width="34" height="39" bordercolor="#C0C0C0" bgcolor="#c0c0c0"
 align="center">3</td>
      <td width="34" height="39" align="center"><br>
      </td>
      <td width="34" height="39" align="center"><br>
      </td>
      <td width="34" height="39" align="center"><br>
      </td>
      <td width="34" height="39" align="center" bgcolor="#ff0000">10</td>
      <td width="34" height="39" align="center">10</td>
      <td width="34" height="39" align="center">10</td>
      <td width="34" height="39" align="center">10</td>
      <td width="34" height="39" align="center">10</td>
      <td width="34" height="39" align="center" bgcolor="#ff0000">20</td>
      <td width="34" height="39" align="center">20</td>
      <td width="35" height="39" align="center">20</td>
      <td width="35" height="39" align="center">20</td>
      <td width="35" height="39" align="center">20</td>
      <td width="35" height="39" align="center">20</td>
      <td width="35" height="39" align="center">20</td>
      <td width="35" height="39" align="center" bgcolor="#ff0000">9</td>
      <td width="35" height="39" align="center">9</td>
      <td width="35" height="39" align="center">9</td>
      <td width="35" height="39" align="center">9</td>
      <td width="35" height="39" align="center">9</td>
    </tr>
    <tr>
      <td width="34" height="39" bordercolor="#C0C0C0" bgcolor="#c0c0c0"
 align="center">4</td>
      <td width="34" height="39" align="center"><br>
      </td>
      <td width="34" height="39" align="center"><br>
      </td>
      <td width="34" height="39" align="center"><br>
      </td>
      <td width="34" height="39" align="center"><br>
      </td>
      <td width="34" height="39" align="center" bgcolor="#ff0000">6</td>
      <td width="34" height="39" align="center">6</td>
      <td width="34" height="39" align="center">6</td>
      <td width="34" height="39" align="center">6</td>
      <td width="34" height="39" align="center">6</td>
      <td width="34" height="39" align="center">6</td>
      <td width="35" height="39" align="center">6</td>
      <td width="35" height="39" align="center">6</td>
      <td width="35" height="39" align="center">6</td>
      <td width="35" height="39" align="center">6</td>
      <td width="35" height="39" align="center">6</td>
      <td width="35" height="39" align="center">6</td>
      <td width="35" height="39" align="center">6</td>
      <td width="35" height="39" align="center">6</td>
      <td width="35" height="39" align="center" bgcolor="#ff0000">11</td>
      <td width="35" height="39" align="center">11</td>
    </tr>
  </tbody>
</table>
</center>
</div>
<p>&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
5 + 9 = 14 page fault</p>
<p><br>
</p>
<br>
<span style="font-weight: bold;"><br style="font-weight: bold;">
Esercizio 4</span><br>
Data una memoria partizionata
in maniera fissa come segue:
<span style="font-weight: bold;"></span>
<table cellpadding="2" cellspacing="2" border="1"
 style="text-align: left; width: 200px;">
  <tbody>
    <tr>
      <td style="vertical-align: top;">Partizione<br>
      </td>
      <td style="vertical-align: top;">Dimensione<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">0</td>
      <td style="vertical-align: top;">200K</td>
    </tr>
    <tr>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">600K</td>
    </tr>
    <tr>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">150K</td>
    </tr>
    <tr>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">500K</td>
    </tr>
  </tbody>
</table>
e dato che il sistema operativo deve allocare
quattro processi P1 di 120K, P2 di 400K, P3 di 180K e P4 di 450K (in
quest'ordine), <br>
scrivere
in quale partizione il sistema alloca ciascun processo se viene usato
l'algoritmo:<span style="font-weight: bold;"><br>
</span>
<ol>
  <li>First Fit</li>
  <li>Best Fit</li>
  <li>Worst Fit<br>
  </li>
</ol>
(se il processo non puo' essere
allocato, segnare "X" come partizione).<br>
<br>
<br>
<span style="font-weight: bold;">Soluzione</span><br>
Nota: le partizioni sono <span style="font-weight: bold;">fisse</span>:
non si possono mettere due processi nella stessa partizione!<br>
<ol>
  <li>First fit: P1:0, P2: 1, P3:3, P4:X<br>
  </li>
  <li>Best fit:&nbsp; P1:2, P2: 3, P3:0, P4:1</li>
  <li>Worst fit: P1:1, P2:3, P3:0, P4:X</li>
</ol>
<span style="font-weight: bold;">Esercizio 5</span><br>
Considerare un file system dove la dimensione di un
blocco logico e' 1KB e con indirizzi di blocchi a 16 bit.<br>
<ol>
  <li>Determinare la dimensione massima di un file in caso
di&nbsp;</li>
  <ol>
    <li>allocazione concatenata</li>
    <li>allocazione indicizzata con due livelli di blocco indice</li>
  </ol>
  <li>Determinare il numero di blocchi effettivamente assegnati ad un
file di
200KB per i due tipi di allocazione.<br>
  </li>
</ol>
<span style="font-weight: bold;">Soluzione<br>
</span>Indirizzi a 16 bit --&gt; 2<sup>16</sup> blocchi fisici<sup><br>
</sup>
<ol>
  <li>Dim. massima</li>
  <ol>
    <li>Allocazione concatenata: ogni blocco ha 1KB-2B=1022 Byte di
spazio dati quindi il file piu grande ha dimensione 2<sup>16</sup> *
1022 Byte</li>
    <li>Allocazione indicizzata: ogni blocco puo contenere 1024/2=512
puntatori, quindi con due livelli: (512)<sup>2</sup>* 1 KB<br>
(senza considerare spazio per la tabella)<br>
      <br>
    </li>
  </ol>
  <li>Numero blocchi</li>
  <ol>
    <li>&nbsp;Dim file/Spazio in un blocco = 200 KB/1022 = 201 blocchi<br>
    </li>
    <li>&nbsp;200 blocchi</li>
  </ol>
</ol>
<br>
<span style="font-weight: bold;">
<br>
</span><br>
<br>
<span style="font-weight: bold;">
</span>
</body>
</html>
